import {
  request
} from '~/services/_utils/request'
import {
  removeStorage
} from '~/utils/storage'

/** 登出 */
export function logout() {
  return new Promise((resolve, reject) => {
    request({
      url: `WeChatLogin/logout`,
      method: 'POST',
      success: function (res) {

        // 清空登录信息缓存
        removeStorage('userInfo')
        removeStorage('Authorization')

        // 回到上一页
        const pages = getCurrentPages(); //获取小程序页面栈
        const beforePage = pages[pages.length - 1]; //获取上个页面的实例对象  -3是上上一个页面
        wx.navigateBack({
          delta: 2,
        });
        beforePage.onLoad();
        wx.showToast({
          icon: 'success',
          title: '登出成功',
        });
        resolve(res);
      },
      fail: function (error) {
        reject(error);
      }
    });
  });
}